package cn.ibizlab.eam.core.eam_core.mapper;

import java.util.List;
import org.apache.ibatis.annotations.*;
import java.util.Map;
import com.baomidou.mybatisplus.core.mapper.BaseMapper;
import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import com.baomidou.mybatisplus.core.metadata.IPage;
import com.baomidou.mybatisplus.core.conditions.Wrapper;
import java.util.HashMap;
import org.apache.ibatis.annotations.Select;
import cn.ibizlab.eam.core.eam_core.domain.EMPlan;
import cn.ibizlab.eam.core.eam_core.filter.EMPlanSearchContext;
import org.springframework.cache.annotation.CacheEvict;
import org.springframework.cache.annotation.Cacheable;
import java.io.Serializable;
import com.baomidou.mybatisplus.core.toolkit.Constants;
import com.alibaba.fastjson.JSONObject;

public interface EMPlanMapper extends BaseMapper<EMPlan>{

    Page<EMPlan> searchDefault(IPage page, @Param("srf") EMPlanSearchContext context, @Param("ew") Wrapper<EMPlan> wrapper) ;
    @Override
    EMPlan selectById(Serializable id);
    @Override
    int insert(EMPlan entity);
    @Override
    int updateById(@Param(Constants.ENTITY) EMPlan entity);
    @Override
    int deleteById(Serializable id);
     /**
      * 自定义查询SQL
      * @param sql
      * @return
      */
     @Select("${sql}")
     List<JSONObject> selectBySQL(@Param("sql") String sql, @Param("et")Map param);

    /**
    * 自定义更新SQL
    * @param sql
    * @return
    */
    @Update("${sql}")
    boolean updateBySQL(@Param("sql") String sql, @Param("et")Map param);

    /**
    * 自定义插入SQL
    * @param sql
    * @return
    */
    @Insert("${sql}")
    boolean insertBySQL(@Param("sql") String sql, @Param("et")Map param);

    /**
    * 自定义删除SQL
    * @param sql
    * @return
    */
    @Delete("${sql}")
    boolean deleteBySQL(@Param("sql") String sql, @Param("et")Map param);

    List<EMPlan> selectByAcclassid(@Param("emacclassid") Serializable emacclassid) ;

    List<EMPlan> selectByEquipid(@Param("emequipid") Serializable emequipid) ;

    List<EMPlan> selectByDpid(@Param("emobjectid") Serializable emobjectid) ;

    List<EMPlan> selectByObjid(@Param("emobjectid") Serializable emobjectid) ;

    List<EMPlan> selectByPlantemplid(@Param("emplantemplid") Serializable emplantemplid) ;

    List<EMPlan> selectByRserviceid(@Param("emserviceid") Serializable emserviceid) ;

    List<EMPlan> selectByRdeptid(@Param("pfdeptid") Serializable pfdeptid) ;

    List<EMPlan> selectByMpersonid(@Param("pfempid") Serializable pfempid) ;

    List<EMPlan> selectByRecvpersonid(@Param("pfempid") Serializable pfempid) ;

    List<EMPlan> selectByRempid(@Param("pfempid") Serializable pfempid) ;

    List<EMPlan> selectByRteamid(@Param("pfteamid") Serializable pfteamid) ;

}
